`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 05/05/2020 01:39:25 PM
// Design Name: 
// Module Name: Lab9_2
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Lab9_3(
    f_crystal,
    rst,
    PS2_CLK,
    PS2_DATA,
    D_ssd,
    ssd_ctl
    );
    input f_crystal, rst;
    inout PS2_DATA, PS2_CLK;
    output [7:0]D_ssd;
    output [3:0]ssd_ctl;
    wire [511:0]key_down;
    wire [8:0]last_change;
    wire key_valid;
    wire [3:0]Display;
    wire [1:0]ssd_clk;
    wire [3:0]state;
    wire [3:0]digit;
    wire clk_10;
    wire [3:0]a_MSB, a_LSB, b_MSB, b_LSB, Operator;
    reg [3:0]Result_0, Result_1, Result_2, Result_3;
    reg  [12:0]tmp;
    wire [12:0]Result;
    reg [3:0]display_0, display_1, display_2, display_3;
    frq_div_clk U0(
    .ssd_clk(ssd_clk),
    .f_crystal(f_crystal), // global clock input
    .rst(rst), // active low reset
    .clk_10(clk_10)
    );
    KeyboardDecoder U1(
    .key_down(key_down),
    .last_change(last_change),
    .key_valid(key_valid),
    .PS2_DATA(PS2_DATA),
    .PS2_CLK(PS2_CLK),
    .rst(rst),
    .clk(f_crystal)
    );
     Keyboard_converter U2(
    .in(last_change),
    .out(digit)
    );
    FSM U_FSM(
    .in(key_valid), //input control
    .clk(f_crystal), // global clock signal
    .rst(rst), // high active reset
    .state(state),
    .Keyboard_in(digit),
    .firstnum_MSB(a_MSB),
    .firstnum_LSB(a_LSB),
    .secondnum_MSB(b_MSB),
    .secondnum_LSB(b_LSB),
    .Result(Result),
    .Operator(Operator),
    .last_changed(last_change)
    );
    always @*
        if(Result[12] ==  1)
            begin
                tmp = 0-Result;
                Result_0 = 4'd0;
                Result_1 = 4'd13;
                Result_2 = tmp /10;
                Result_3 = tmp % 10;
            end
        else
            begin
                tmp = Result;
                Result_0 = tmp / 1000;
                Result_1 = (tmp-Result_0*1000) / 100;
                Result_2 = (tmp-Result_0*1000-Result_1*100)/10;
                Result_3 = tmp % 10;
            end
    always @*
        if(state == 4'b0010)
            begin
                display_0 = 4'd0;
                display_1 = 4'd0;
                display_2 = a_MSB;
                display_3 = 4'd0;  
            end
        else if(state == 4'b0011)
             begin
                display_0 = 4'd0;
                display_1 = 4'd0;
                display_2 = a_MSB;
                display_3 = 4'd0;  
              end
        else if(state == 4'b0100)
             begin
                display_0 = 4'd0;
                display_1 = 4'd0;
                display_2 = a_MSB;
                display_3 = a_LSB;  
              end
         else if(state == 4'b0101)
              begin
                 display_0 = 4'd0;
                 display_1 = 4'd0;
                 display_2 = a_MSB;
                 display_3 = a_LSB;  
               end
        else if(state == 4'b0110)
            begin
                display_0 = 4'd0;
                display_1 = 4'd0;
                display_2 = 4'd0;
                display_3 = Operator;  
            end
        else if(state == 4'b0111)
            begin
              display_0 = 4'd0;
              display_1 = 4'd0;
              display_2 = 4'd0;
              display_3 = Operator;  
            end
        else if(state == 4'b1000)
            begin
                 display_0 = 4'd0;
                 display_1 = 4'd0;
                 display_2 = b_MSB;
                 display_3 = 4'd0;  
            end
        else if(state == 4'b1001)
           begin
                display_0 = 4'd0;
                display_1 = 4'd0;
                display_2 = b_MSB;
                display_3 = 4'd0;  
           end
        else if(state == 4'b1010)
            begin
                 display_0 = 4'd0;
                 display_1 = 4'd0;
                 display_2 = b_MSB;
                 display_3 = b_LSB;  
            end
        else if(state == 4'b1011)
            begin
                 display_0 = 4'd0;
                 display_1 = 4'd0;
                 display_2 = b_MSB;
                 display_3 = b_LSB;  
            end
        else if(state == 4'b0000)
            begin
                display_0 = Result_0;
                display_1 = Result_1;
                display_2 = Result_2;
                display_3 = Result_3;  
            end
        else
            begin
                display_0 = 4'd0;
                display_1 = 4'd0;
                display_2 = 4'd0;
                display_3 = 4'd0;
            end
            

    scan_ctl U3(
    .ssd_ctl(ssd_ctl), // ssd display control signal 
    .ssd_in0(display_0), // output to ssd display
    .ssd_in1(display_1),
    .ssd_in2(display_2),
    .ssd_in3(display_3),
    .ssd_in(Display),
    .ssd_ctl_clk(ssd_clk)
    );
    Display_7_segment U4(.D_ssd(D_ssd), .i(Display));
endmodule
